# Copyright 2005-8, TIG
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# Name :          invertselection.rb
# Date :          v1.0 8/7/5
#				  v1.1 10/2/8 Edges of selected faces are respected.                             
#-----------------------------------------------------------------------------
# This script will invert the current selection from the context menu.
# It will respect the nesting level if you are editing a group / component.
### 
require 'sketchup.rb'
###
class InvertSelection_
 def InvertSelection_::validate ###
  model=Sketchup.active_model
  ss=model.selection 
  return nil if (ss.empty?)
  return true
 end
#
 def InvertSelection_::toggle 
  model=Sketchup.active_model
  ss=model.selection
  ### add hidden smoothed edges to faces in selections ###
  edges=[]
  ss.each{|e|fedges=[]
    fedges=e.edges if e.typename=="Face"
	fedges.each{|ee|edges.push(ee)} if not fedges.empty?
  }
  edges.each{|e|ss.add(e)} if not edges.empty?
  ###
  ### Find everything in the current edit level. 
  model.active_entities.each {|e|ss.toggle(e)}###Flip selection
 end
end # Class 
###
if( not file_loaded?("invertselection.rb") )
  UI.add_context_menu_handler do |menu|
    menu.add_separator if (InvertSelection_.validate)
    menu.add_item("Invert Selection") {InvertSelection_.toggle} if InvertSelection_.validate
  end
end
file_loaded "invertselection.rb"
#